var ContactManager = (function () {
    function ContactManager() {
        this.contacts = [];
        document.querySelector(".up-cloud").onclick = ContactManager.exportNaServer;
        document.querySelector(".down-cloud").onclick = ContactManager.importServer;
        document.querySelector(".down-file").onclick = ContactManager.exportFile;
        document.querySelector(".up-file").onclick = ContactManager.importFile;
        document.querySelector(".del-all").onclick = ContactManager.deleteAll;
        if (window.localStorage.getItem("backup")) {
            this.contacts = JSON.parse(window.localStorage.getItem("backup"));
        }
        else {
            this.contacts.push(Contact.getRandom1());
            this.contacts.push(Contact.getRandom2());
            this.contacts.push(Contact.getRandom3());
            this.contacts.push(Contact.getRandom4());
            this.contacts.push(Contact.getRandom5());
        }
    }
    ContactManager.backup = function (save) {
        if (save) {
            save();
        }
        window.localStorage.setItem("backup", JSON.stringify(contactManager.contacts));
    };
    ContactManager.deleteAll = function () {
        var x = prompt("Opravdu smazat vše? (A pro ano, cokoliv jiného pro ne)");
        if (x.toUpperCase() == "A") {
            contactManager.contacts = [];
            contactList.syncPeoples();
        }
    };
    ContactManager.addNewCOntact = function () {
        var c = new Contact();
        c.jmeno = "Nový";
        c.prijmeni = "Kontakt";
        c.stitky = "";
        c.ulice = "";
        c.psc = "";
        c.emails = [];
        c.phones = [];
        c.mesto = "";
        c.obr = "";
        contactManager.contacts.push(c);
        contactList.syncPeoples();
        ContactManager.showEdit(c);
    };
    ContactManager.exportNaServer = function () {
        var data = JSON.stringify(contactManager.contacts);
        var xhr = new XMLHttpRequest();
        xhr.open("PUT", "http://adresar.proed.cz/302-cloud/");
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                alert("uloženo do cloudu");
            }
        }.bind(this);
        xhr.send(data);
    };
    ContactManager.showDetail = function (c) {
        Page.show("detail");
        document.querySelector(".de-edit").onclick = ContactManager.showEdit.bind(null, c);
        document.querySelector(".de-jmeno").textContent = c.jmeno;
        document.querySelector(".de-prijmeni").textContent = c.prijmeni;
        document.querySelector(".de-title").textContent = c.jmeno + " " + c.prijmeni;
        document.querySelector(".de-stitky").textContent = c.stitky;
        document.querySelector(".de-adresa").innerHTML = c.ulice + "<br>" + c.psc + " " + c.mesto;
        var emails = document.querySelector(".de-emails");
        var mobils = document.querySelector(".de-mobils");
        emails.innerHTML = "";
        mobils.innerHTML = "";
        c.emails.forEach(function (e) {
            var html = '<label>' + e.jmeno + ' e-mail:</label>';
            html += '<span class="de-email">' + e.email + '</span>';
            html += '<br />';
            emails.innerHTML += html;
        });
        c.phones.forEach(function (e) {
            var html = '<label>' + e.jmeno + ':</label>';
            html += '<span class="de-mobil">' + e.mobil + '</span>';
            html += '<br />';
            emails.innerHTML += html;
        });
    };
    ContactManager.exportFile = function () {
        var data = JSON.stringify(contactManager.contacts);
        var el = document.createElement("a");
        el.href = 'data:text/plain;charset=utf-8,' + encodeURIComponent(data);
        el.download = "kontakty.json";
        document.body.appendChild(el);
        el.click();
        document.body.removeChild(el);
    };
    ContactManager.importServer = function () {
        var xhr = new XMLHttpRequest();
        xhr.open("GET", "http://adresar.proed.cz/302-cloud/");
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                var data = JSON.parse(xhr.responseText);
                var x = prompt("Přidat (zadej A), přepsat (zadej O) vše, nědělat nic (zadej cokoliv jiného)?");
                if (x.toUpperCase() == "A") {
                    data.forEach(function (c) {
                        contactManager.contacts.push(c);
                    });
                }
                if (x.toUpperCase() == "O") {
                    contactManager.contacts = data;
                }
                contactList.syncPeoples();
            }
        }.bind(this);
        xhr.send();
        Page.show("welcome");
    };
    ContactManager.importFile = function () {
        var el = document.createElement("input");
        el.type = "file";
        document.body.appendChild(el);
        el.onchange = function (e) {
            var fr = new FileReader();
            fr.onload = function () {
                var data = JSON.parse(fr.result);
                var x = prompt("Přidat (zadej A), přepsat (zadej O) vše, nědělat nic (zadej cokoliv jiného)?");
                if (x.toUpperCase() == "A") {
                    data.forEach(function (c) {
                        contactManager.contacts.push(c);
                    });
                }
                if (x.toUpperCase() == "O") {
                    contactManager.contacts = data;
                }
                contactList.syncPeoples();
            };
            fr.readAsText(el.files[0]);
        };
        el.click();
        document.body.removeChild(el);
        Page.show("welcome");
    };
    ContactManager.showEdit = function (c) {
        var inputs = document.querySelectorAll(".edit input");
        for (var i = 0; i < inputs.length; i++) {
            inputs[i].onchange = ContactManager.backup.bind(null, ContactManager.saveChanges.bind(null, c));
        }
        Page.show("edit");
        document.querySelector(".ed-jmeno").value = c.jmeno;
        document.querySelector(".ed-prijmeni").value = c.prijmeni;
        document.querySelector(".ed-title").textContent = c.jmeno + " " + c.prijmeni;
        document.querySelector(".ed-stitky").value = c.stitky;
        document.querySelector(".add-emmob-email").onclick = function () {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + "" + '" />';
            html += '<input type="email" class="emmob" value="' + "" + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            el.querySelector(".del-em-mob").onclick = function (el) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            emails.appendChild(el);
        };
        var emails = document.querySelector(".email-area .ed-emails");
        emails.innerHTML = "";
        c.emails.forEach(function (e) {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + e.jmeno + '" />';
            html += '<input type="email" class="emmob" value="' + e.email + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            el.querySelector(".del-em-mob").onclick = function (el) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            emails.appendChild(el);
        });
        document.querySelector(".add-emmob-email").onclick = function () {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + "" + '" />';
            html += '<input type="email" class="emmob" value="' + "" + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            el.querySelector(".del-em-mob").onclick = function (el) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            emails.appendChild(el);
        };
        var mobils = document.querySelector(".mobil-area .ed-emails");
        mobils.innerHTML = "";
        c.phones.forEach(function (e) {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + e.jmeno + '" />';
            html += '<input type="email" class="emmob" value="' + e.mobil + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            el.querySelector(".del-em-mob").onclick = function (el) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            mobils.appendChild(el);
        });
        document.querySelector(".add-emmob-mobil").onclick = function () {
            var el = document.createElement("div");
            el.classList.add("ed-mobil");
            var html = "";
            html += '<input type="text" class="title" value="' + "" + '" />';
            html += '<input type="email" class="emmob" value="' + "" + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            el.querySelector(".del-em-mob").onclick = function (el) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            mobils.appendChild(el);
        };
        document.querySelector(".ed-ulice").value = c.ulice;
        document.querySelector(".ed-mesto").value = c.mesto;
        document.querySelector(".ed-psc").value = c.psc;
        document.querySelector(".del-contact").onclick = ContactManager.deleteContact.bind(null, c);
        document.querySelector(".ed-save").onclick = ContactManager.saveChanges.bind(null, c);
        document.querySelector(".edit .close").onclick = function () {
            ContactManager.showDetail(c);
        };
    };
    ContactManager.deleteContact = function (c) {
        contactManager.contacts.splice(contactManager.contacts.indexOf(c), 1);
        contactList.syncPeoples();
        Page.show("welcome");
    };
    ContactManager.saveChanges = function (c) {
        c.jmeno = document.querySelector(".ed-jmeno").value;
        c.prijmeni = document.querySelector(".ed-prijmeni").value;
        c.stitky = document.querySelector(".ed-stitky").value;
        var emailTitles = document.querySelectorAll(".email-area .ed-emails .title");
        var emailEmails = document.querySelectorAll(".email-area .ed-emails .emmob");
        var mobilTitles = document.querySelectorAll(".mobil-area .ed-emails .title");
        var mobilEmails = document.querySelectorAll(".mobil-area .ed-emails .emmob");
        c.emails = [];
        c.phones = [];
        for (var i = 0; i < emailTitles.length; i++) {
            var e = new Email();
            e.jmeno = emailTitles[i].value;
            e.email = emailEmails[i].value;
            c.emails.push(e);
        }
        for (var i = 0; i < mobilTitles.length; i++) {
            var m = new Mobil();
            m.jmeno = mobilTitles[i].value;
            m.mobil = mobilEmails[i].value;
            c.phones.push(m);
        }
        c.ulice = document.querySelector(".ed-ulice").value;
        c.mesto = document.querySelector(".ed-mesto").value;
        c.psc = document.querySelector(".ed-psc").value;
        contactList.syncPeoples();
        ContactManager.showEdit(c);
    };
    return ContactManager;
}());
var contactManager;
//# sourceMappingURL=ContactManager.js.map