﻿class ContactManager {

    public contacts: Array<Contact> = [];

    static backup(save: Function) {
        if (save) {
            save();
        }
        window.localStorage.setItem("backup", JSON.stringify(contactManager.contacts));
    }

    constructor() {
        (<HTMLButtonElement>document.querySelector(".up-cloud")).onclick = ContactManager.exportNaServer;
        (<HTMLButtonElement>document.querySelector(".down-cloud")).onclick = ContactManager.importServer;
        (<HTMLButtonElement>document.querySelector(".down-file")).onclick = ContactManager.exportFile;
        (<HTMLButtonElement>document.querySelector(".up-file")).onclick = ContactManager.importFile;
        (<HTMLButtonElement>document.querySelector(".del-all")).onclick = ContactManager.deleteAll;
        if (window.localStorage.getItem("backup")) {
            this.contacts = JSON.parse(window.localStorage.getItem("backup"));
        } else {
            this.contacts.push(Contact.getRandom1());
            this.contacts.push(Contact.getRandom2());
            this.contacts.push(Contact.getRandom3());
            this.contacts.push(Contact.getRandom4());
            this.contacts.push(Contact.getRandom5());
        }
    }

    static deleteAll() {
        var x = prompt("Opravdu smazat vše? (A pro ano, cokoliv jiného pro ne)");
        if (x.toUpperCase() == "A") {
            contactManager.contacts = [];
            contactList.syncPeoples();
        }
    }

    static addNewCOntact() {
        var c = new Contact();
        c.jmeno = "Nový";
        c.prijmeni = "Kontakt";
        c.stitky = "";
        c.ulice = "";
        c.psc = "";
        c.emails = [];
        c.phones = [];
        c.mesto = "";
        c.obr = "";
        contactManager.contacts.push(c);
        contactList.syncPeoples();
        ContactManager.showEdit(c);
    }

    static exportNaServer() {
        var data = JSON.stringify(contactManager.contacts);
        var xhr = new XMLHttpRequest();
        xhr.open("PUT", "http://adresar.proed.cz/302-cloud/");
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4 && xhr.status == 200) {
                alert("uloženo do cloudu");
            }
        }.bind(this);
        xhr.send(data);
    }

    static showDetail(c: Contact) {
        Page.show("detail");
        (<HTMLButtonElement>document.querySelector(".de-edit")).onclick = ContactManager.showEdit.bind(null, c);
        document.querySelector(".de-jmeno").textContent = c.jmeno;
        document.querySelector(".de-prijmeni").textContent = c.prijmeni;
        document.querySelector(".de-title").textContent = c.jmeno + " " + c.prijmeni;
        document.querySelector(".de-stitky").textContent = c.stitky;
        document.querySelector(".de-adresa").innerHTML = c.ulice + "<br>" + c.psc + " " + c.mesto;
        var emails = document.querySelector(".de-emails");
        var mobils = document.querySelector(".de-mobils");
        emails.innerHTML = "";
        mobils.innerHTML = "";
        c.emails.forEach(function(e) {
            var html = '<label>' + e.jmeno + ' e-mail:</label>';
            html += '<span class="de-email">' + e.email + '</span>';
            html += '<br />';
            emails.innerHTML += html;
        });
        c.phones.forEach(function(e) {
            var html = '<label>' + e.jmeno + ':</label>';
            html += '<span class="de-mobil">' + e.mobil + '</span>';
            html += '<br />';
            emails.innerHTML += html;
        });
    }

    static exportFile() {
        var data = JSON.stringify(contactManager.contacts);
        var el = document.createElement("a");
        el.href = 'data:text/plain;charset=utf-8,' + encodeURIComponent(data);
        el.download = "kontakty.json";

        document.body.appendChild(el);
        el.click();
        document.body.removeChild(el);
    }

    static importServer() {
        var xhr = new XMLHttpRequest();
        xhr.open("GET", "http://adresar.proed.cz/302-cloud/");
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4 && xhr.status == 200) {
                var data = JSON.parse(xhr.responseText);
                var x = prompt("Přidat (zadej A), přepsat (zadej O) vše, nědělat nic (zadej cokoliv jiného)?");
                if (x.toUpperCase() == "A") {
                    data.forEach(function(c) {
                        contactManager.contacts.push(c);
                    });
                }
                if (x.toUpperCase() == "O") {
                    contactManager.contacts = data;
                }
                contactList.syncPeoples();
            }
        }.bind(this);
        xhr.send();
        Page.show("welcome");
    }

    static importFile() {
        var el = document.createElement("input");
        el.type = "file";
        document.body.appendChild(el);
        el.onchange = function(e) {
            var fr = new FileReader();
            fr.onload = function() {
                var data: Array<Contact> = JSON.parse(fr.result);
                var x = prompt("Přidat (zadej A), přepsat (zadej O) vše, nědělat nic (zadej cokoliv jiného)?");
                if (x.toUpperCase() == "A") {
                    data.forEach(function(c) {
                        contactManager.contacts.push(c);
                    });
                }
                if (x.toUpperCase() == "O") {
                    contactManager.contacts = data;
                }
                contactList.syncPeoples();
            }
            fr.readAsText(el.files[0]);
        }
        el.click();
        document.body.removeChild(el);
        Page.show("welcome");
    }

    static showEdit(c: Contact) {

        var inputs = document.querySelectorAll(".edit input");
        for (var i = 0; i < inputs.length; i++) {
            (<HTMLInputElement>inputs[i]).onchange = ContactManager.backup.bind(null, ContactManager.saveChanges.bind(null, c));
        }

        Page.show("edit");
        (<HTMLInputElement>document.querySelector(".ed-jmeno")).value = c.jmeno;
        (<HTMLInputElement>document.querySelector(".ed-prijmeni")).value = c.prijmeni;
        (<HTMLInputElement>document.querySelector(".ed-title")).textContent = c.jmeno + " " + c.prijmeni;
        (<HTMLInputElement>document.querySelector(".ed-stitky")).value = c.stitky;

        (<HTMLButtonElement>document.querySelector(".add-emmob-email")).onclick = function() {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + "" + '" />';
            html += '<input type="email" class="emmob" value="' + "" + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            (<HTMLButtonElement>el.querySelector(".del-em-mob")).onclick = function(el: HTMLElement) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            emails.appendChild(el);
        }


        var emails = document.querySelector(".email-area .ed-emails");
        emails.innerHTML = "";
        c.emails.forEach(function(e) {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + e.jmeno + '" />';
            html += '<input type="email" class="emmob" value="' + e.email + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            (<HTMLButtonElement>el.querySelector(".del-em-mob")).onclick = function(el: HTMLElement) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            emails.appendChild(el);
        });
        (<HTMLButtonElement>document.querySelector(".add-emmob-email")).onclick = function() {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + "" + '" />';
            html += '<input type="email" class="emmob" value="' + "" + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            (<HTMLButtonElement>el.querySelector(".del-em-mob")).onclick = function(el: HTMLElement) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            emails.appendChild(el);
        }
        var mobils = document.querySelector(".mobil-area .ed-emails");
        mobils.innerHTML = "";
        c.phones.forEach(function(e) {
            var el = document.createElement("div");
            el.classList.add("ed-email");
            var html = "";
            html += '<input type="text" class="title" value="' + e.jmeno + '" />';
            html += '<input type="email" class="emmob" value="' + e.mobil + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            (<HTMLButtonElement>el.querySelector(".del-em-mob")).onclick = function(el: HTMLElement) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            mobils.appendChild(el);
        });

        (<HTMLButtonElement>document.querySelector(".add-emmob-mobil")).onclick = function() {
            var el = document.createElement("div");
            el.classList.add("ed-mobil");
            var html = "";
            html += '<input type="text" class="title" value="' + "" + '" />';
            html += '<input type="email" class="emmob" value="' + "" + '" />';
            html += '<button class="del-em-mob red">';
            html += '<img src="icons/remove.svg" class="svg" alt="odstranit" />';
            html += '</button>';
            el.innerHTML = html;
            (<HTMLButtonElement>el.querySelector(".del-em-mob")).onclick = function(el: HTMLElement) {
                el.parentElement.removeChild(el);
            }.bind(null, el);
            mobils.appendChild(el);
        };


        (<HTMLInputElement>document.querySelector(".ed-ulice")).value = c.ulice;
        (<HTMLInputElement>document.querySelector(".ed-mesto")).value = c.mesto;
        (<HTMLInputElement>document.querySelector(".ed-psc")).value = c.psc;
        (<HTMLButtonElement>document.querySelector(".del-contact")).onclick = ContactManager.deleteContact.bind(null, c);
        (<HTMLButtonElement>document.querySelector(".ed-save")).onclick = ContactManager.saveChanges.bind(null, c);
        (<HTMLButtonElement>document.querySelector(".edit .close")).onclick = function() {
            ContactManager.showDetail(c);
        }


    }

    public static deleteContact(c: Contact) {
        contactManager.contacts.splice(contactManager.contacts.indexOf(c), 1);
        contactList.syncPeoples();
        Page.show("welcome");
    }

    public static saveChanges(c: Contact) {

        c.jmeno = (<HTMLInputElement>document.querySelector(".ed-jmeno")).value;
        c.prijmeni = (<HTMLInputElement>document.querySelector(".ed-prijmeni")).value;
        c.stitky = (<HTMLInputElement>document.querySelector(".ed-stitky")).value;

        var emailTitles = document.querySelectorAll(".email-area .ed-emails .title");
        var emailEmails = document.querySelectorAll(".email-area .ed-emails .emmob");
        var mobilTitles = document.querySelectorAll(".mobil-area .ed-emails .title");
        var mobilEmails = document.querySelectorAll(".mobil-area .ed-emails .emmob");

        c.emails = [];
        c.phones = [];

        for (var i = 0; i < emailTitles.length; i++) {
            var e = new Email();
            e.jmeno = (<HTMLInputElement>emailTitles[i]).value;
            e.email = (<HTMLInputElement>emailEmails[i]).value;
            c.emails.push(e);
        }
        for (var i = 0; i < mobilTitles.length; i++) {
            var m = new Mobil();
            m.jmeno = (<HTMLInputElement>mobilTitles[i]).value;
            m.mobil = (<HTMLInputElement>mobilEmails[i]).value;
            c.phones.push(m);
        }

        c.ulice = (<HTMLInputElement>document.querySelector(".ed-ulice")).value;
        c.mesto = (<HTMLInputElement>document.querySelector(".ed-mesto")).value;
        c.psc = (<HTMLInputElement>document.querySelector(".ed-psc")).value;

        contactList.syncPeoples();
        ContactManager.showEdit(c);
    }
}

var contactManager: ContactManager;